package weka.filters.unsupervised.attribute;

import no.uib.cipr.matrix.DenseVector;
import no.uib.cipr.matrix.Vector;
import weka.core.Attribute;
import weka.core.Capabilities;
import weka.core.DenseInstance;
import weka.core.Instances;
import weka.filters.SimpleBatchFilter;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.DoubleStream;

public class NeutralFilter extends SimpleBatchFilter {
    protected int m_ImageSize;

    @Override
    public String globalInfo() {
        return "This filter returns the original RGB pixels as attributes.";
    }

    /**
     * The capabilities of this filter.
     *
     * @return the capabilities
     */
    @Override
    public Capabilities getCapabilities() {
        Capabilities result = super.getCapabilities();
        result.enable(Capabilities.Capability.STRING_ATTRIBUTES);
        result.enableAllClasses();
        result.enable(Capabilities.Capability.MISSING_CLASS_VALUES);
        return result;
    }

    /**
     * We need to have access to the full input format so that we can read the images.
     *
     * @return true
     */
    @Override
    public boolean allowAccessToFullInputFormat() {
        return true;
    }

    /**
     * The method used to establish the format of the data generated by this filter, as an Instances object.
     *
     * @param data the input dataset, with a string attribute containing the file names of the images
     * @return an Instances object that provides the "header" information for the data generated by this filter
     * (i.e., an Instances object that does not contain any actual instances but does contain a list of attributes).
     */
    @Override
    protected Instances determineOutputFormat(Instances data) throws Exception {

        if (m_Debug) {
            System.err.println("Determining output format.");
        }
        int imgSize = -1;
        for (int i = 0; i < data.numInstances(); i++) {
            String fileName = data.instance(i).stringValue(0);
            BufferedImage img = null;
            try {
                img = ImageIO.read(new File(fileName));
            } catch (Exception ex) {
                System.err.println("Could not load: " + fileName);
            }
            if (img.getWidth() != img.getHeight()) {
                throw new IllegalArgumentException("Image " + fileName + " is not square.");
            }
            if (imgSize == -1) {
                imgSize = img.getWidth();
            } else if (imgSize != img.getWidth()) {
                throw new IllegalArgumentException("Image " + fileName + " has different size.");
            }
        }
        m_ImageSize = imgSize;
        if (m_Debug) {
            System.err.println("Image size is: " + imgSize);
        }

        int numFeatures = imgSize * imgSize * 3;

        ArrayList<Attribute> atts = new ArrayList<>(numFeatures + 1);
        for (int i = 0; i < numFeatures; i++) {
            atts.add(new Attribute("x" + (i + 1)));
        }
        if (data.classIndex() > -1) {
            atts.add((Attribute) data.classAttribute().copy());
        }
        Instances output = new Instances("features", atts, 0);
        output.setClassIndex(output.numAttributes() - 1);
        if (m_Debug) {
            System.err.println("Finished determining output format with " + output.numAttributes() + " attributes.");
        }
        return output;
    }

    /**
     * The method that processes the given dataset and outputs the filtered data.
     *
     * @param data the input data to be filtered, with a string attribute containing the file names of the images
     * @return the filtered data, consisting of feature vectors ready for other machine learning algorithms
     */
    @Override
    protected Instances process(Instances data) throws Exception {
        Instances output = getOutputFormat();
        System.err.println("Process start.");

        double[] ones = new double[m_ImageSize * m_ImageSize * 3];
        Arrays.fill(ones, 1);
        final DenseVector vectorOneOverN = new DenseVector(ones)
                .scale(1. / (m_ImageSize * m_ImageSize * 3));
        final DenseVector vectorOnes = new DenseVector(ones);

        for (int i = 0; i < data.numInstances(); i++) {
            String fileName = data.instance(i).stringValue(0);
            BufferedImage img = null;
            try {
                img = ImageIO.read(new File(fileName));
                int[] pixels = new int[img.getWidth() * img.getHeight()];
                img.getRGB(0, 0, img.getWidth(), img.getHeight(), pixels, 0, img.getWidth());

                // convert the channels: all Rs, all Gs and all Bs must be placed in the same order as
                // that in training.
                DoubleStream streamR = Arrays.stream(pixels).mapToDouble(p -> (p >> 16) & 0xff);
                DoubleStream streamG = Arrays.stream(pixels).mapToDouble(p -> (p >> 8) & 0xff);
                DoubleStream streamB = Arrays.stream(pixels).mapToDouble(p -> p & 0xff);

                DoubleStream streamFeatures;
                if (false) {
                    streamFeatures = Arrays.stream(new double[0]);
                    for (DoubleStream stream : new DoubleStream[]{streamR, streamG, streamB}) {
                        double[] features = stream.toArray();
                        DenseVector vec = new DenseVector(features, false);
                        Vector centeredVec = vec.add(-vec.dot(vectorOneOverN), vectorOnes);
                        double norm = centeredVec.norm(Vector.Norm.Two);
                        DenseVector normalizedVec = (DenseVector) centeredVec.scale(1.0 / Math.sqrt((norm * norm) / vec.size() + 10));
                        streamFeatures = DoubleStream.concat(streamFeatures,
                                Arrays.stream(normalizedVec.getData()));
                    }
                } else {
                    double[] features = DoubleStream.concat(DoubleStream.concat(streamR, streamG), streamB).toArray();
                    DenseVector vec = new DenseVector(features, false);
                    Vector centeredVec = vec.add(-vec.dot(vectorOneOverN), vectorOnes);
                    double norm = centeredVec.norm(Vector.Norm.Two);
                    DenseVector normalizedVec = (DenseVector) centeredVec.scale(1.0 / Math.sqrt((norm * norm) / vec.size() + 10));
                    streamFeatures = Arrays.stream(normalizedVec.getData());
                }

                DoubleStream streamClassValue = Arrays.stream(new double[]{data.instance(i).classValue()});
                double[] outputFeatures = DoubleStream.concat(streamFeatures, streamClassValue).toArray();
                if (outputFeatures.length != output.numAttributes()) {
                    System.err.println("number of attribute does not match.");
                }
                output.add(new DenseInstance(data.instance(i).weight(), outputFeatures));
            } catch (IOException e) {
                System.err.println("File " + fileName + " could not be read");
            }
        }
        System.err.println("Process completed.");
        return output;
    }

}
